package jcademo.client;

import java.io.IOException;

import javax.annotation.Resource;
import javax.resource.ResourceException;
import javax.resource.cci.Connection;
import javax.resource.cci.ConnectionFactory;
import javax.resource.cci.IndexedRecord;
import javax.resource.cci.Interaction;
import javax.resource.cci.InteractionSpec;
import javax.resource.cci.MappedRecord;
import javax.resource.cci.RecordFactory;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

@WebServlet(urlPatterns={"/testmultcp_cci"})
public class TestMulTCP_CCI extends HttpServlet {
    private static final long serialVersionUID = 1L;
    @Resource(mappedName = "java:/eis/MulTCP_CCI")
    private ConnectionFactory cf;
    @Resource(mappedName = "java:/eis/MulTCP_IS")
    private InteractionSpec is;
    @Override
    public void doGet(HttpServletRequest req, HttpServletResponse resp) throws IOException {
    	try {
    		int c;
    		// open
    		Connection con = cf.getConnection();
    		Interaction i = con.createInteraction();
    		RecordFactory rf = cf.getRecordFactory();
    		// test index records
    		IndexedRecord ir = rf.createIndexedRecord("AB");
    		ir.set(0, 123);
    		ir.set(1, 456);
    		IndexedRecord oir = (IndexedRecord)i.execute(is, ir);
    		c = (Integer)oir.get(0);
			resp.getWriter().println(c);
			// test mapped record
    		MappedRecord mr = rf.createMappedRecord("AB");
    		mr.put("A", 123);
    		mr.put("B", 456);
    		MappedRecord omr = (MappedRecord)i.execute(is, mr);
    		c = (Integer)omr.get("C");
			resp.getWriter().println(c);
			// close
    		con.close();
		} catch (ResourceException e) {
			e.printStackTrace();
		} 
    }
}