package jcademo.raoutbound.permtcp;

import javax.resource.ResourceException;
import javax.resource.spi.ActivationSpec;
import javax.resource.spi.BootstrapContext;
import javax.resource.spi.ResourceAdapter;
import javax.resource.spi.endpoint.MessageEndpointFactory;
import javax.resource.spi.work.Work;
import javax.resource.spi.work.WorkException;
import javax.resource.spi.work.WorkManager;
import javax.transaction.xa.XAResource;

// JCA Adapter
public class PermTCPAdapter implements ResourceAdapter {
	private String host;
	private int port;
	public String getHost() {
		return host;
	}
	public void setHost(String host) {
		this.host = host;
	}
	public int getPort() {
		return port;
	}
	public void setPort(int port) {
		this.port = port;
	}
	private Work w;
	@Override
	public void start(BootstrapContext bctx) {
		WorkManager wm = bctx.getWorkManager();
		try {
			w = new PermTCPWorker(host, port);
			wm.scheduleWork(w);
		} catch (WorkException e) {
			e.printStackTrace();
		}
	}
	@Override
	public void endpointActivation(MessageEndpointFactory mepf, ActivationSpec as) {
	}
	@Override
	public void endpointDeactivation(MessageEndpointFactory mepf, ActivationSpec as) {
	}
	@Override
	public void stop() {
		w.release();
	}
	@Override
	public XAResource[] getXAResources(ActivationSpec[] as) throws ResourceException {
		throw new ResourceException("no XA support");
	}
	@Override
	public int hashCode() {
		return super.hashCode();
	}
	@Override
	public boolean equals(Object o) {
		return this == o;
	}
}
